unit StrLIB;

interface

uses
  SysUtils, StdCtrls;

procedure AddToBuff(var Buff: PChar; S: String);
procedure AddToPChar(var Buff: PChar; AddS: PChar);
function  GetClearStr(Size: Word): PChar;
function  GetMemo2Buffer(Memo: TMemo): PChar;
procedure MyStrDispose(var P: PChar);

implementation

function NilPtr(P: PChar): Boolean;
begin
  Result := (P = nil) or (P^ = #0);
end;

procedure MyStrDispose(var P: PChar);
begin
  if not NilPtr(P) then
  begin
    Dec(P, SizeOf(Cardinal));
    FreeMem(P, Cardinal(Pointer(P)^));
  end;
  P := nil;
end;

function GetClearStr(Size: Word): PChar;
var
  P: PChar;
begin
  P := StrAlloc(Size);    { Allocate size }
  FillChar(P^, Size, #0); { stralloc doesn't fill with zeroes }
  Result := P;
end;

function GetMemo2Buffer(Memo: TMemo): PChar;
var
  L:Integer;
  Buffer: PChar;
begin
  Result:=nil;
  L:=Memo.GetTextLen+1;
  if L=1 then Exit;
  Buffer:=GetClearStr(L);
  Memo.GetTextBuf(Buffer,L);
  Result:=Buffer;
end;

procedure AddToBuff(var Buff: PChar; S: String);
var
  Len: Integer;
  P: PChar;
  Size: Word;
begin
  Len := Length(S);
  if Len = 0 then Exit;
  if NilPtr(Buff) then Size := Len
  else Size := Len+StrLen(Buff);
  P := GetClearStr(Size+1);
  if not NilPtr(Buff) then
  begin
    StrCopy(P, Buff);
    MyStrDispose(Buff);
  end;
  StrPCopy(@P[Size-Len], S);
  Buff := P;
end;

procedure AddToPChar(var Buff: PChar; AddS: PChar);
var
  P: PChar;
  Len, Size: Word;
begin
  if NilPtr(AddS) then Exit;
  Len := StrLen(Adds);
  if NilPtr(Buff) then Size := Len
  else Size := Len+StrLen(Buff);
  P := GetClearStr(Size+1);
  if NilPtr(Buff) then StrCopy(P, AddS)
  else
  begin
    StrCat(StrCopy(P, Buff), AddS);
    MyStrDispose(Buff);
  end;
  Buff := P;
end;

end.
